%%
clc
clear;

%% read image and construct linear operator
img = im2double(imread('cat_noisy.jpg'));
imshow(img);
[ny, nx, c] = size(img);

%% TODO: vectorization and construct the linear operator for 3 channels

%% initialize the variable and parameters
u = f;
max_iters = 100;

% huber parameter
epsilon = 0.1;

% weight for regularizor
rho = 0.6;

% arrays to record the energy.
energy = zeros(1,max_iters);
norm_gradient = zeros(1, max_iters);

% parameters for line search
c1 = 0.001;
c2 = 0.02;
    
alpha_max = 100;
alpha0 = 0;  

%% TODO: Implement line search and record the energy, norm of gradient
for i = 1:max_iters
     
    fprintf('iteration: %d, energy: %.4e, norm of gradient: %.4e\n', i, energy(i), norm_gradient(i));
end
%% visualization
figure(1)
imshow(reshape(u, ny, nx,c));
figure(2)
subplot(1, 2, 1);
plot(energy);
subplot(1,2,2);
plot(norm_gradient);